#include <p18cxxx.h>
#define  USE_AND_MASKS
#include <pconfig.h>	// choix des fonctions en fonction du type de pic
#include <delays.h>
#include <stdio.h>
#include <timers.h>		// Timers
#include <usart.h>		// RS232
#include "HardwareProfile.h"					
#pragma config OSC = INTIO67	// horloge interne
//#pragma config OSC = HS	// horloge externe
#pragma config WDT=OFF		// whatch dog
#pragma config LVP=OFF
/***********************************************************************************************/
#define led PORTBbits.RB0
#define buz PORTBbits.RB1
#define trig PORTBbits.RB3
#define c PORTBbits.RB4
#define s PORTBbits.RB5
#define opto PORTCbits.RC2
#define echopulse PORTCbits.RC1
int val;
/*******************************************************************************************/
//  Init
/*******************************************************************************************/
void Setup(void)
{
	TRISA=0;	// Port A en sortie
	TRISC=0x0f;	// Pf Port C en entree PF en sortie
	OSCCON=0x70;	//  8MHz horloge interne
	ADCON1=0x0E;	// AN0 = A toutes les autres entres en analogique D
	TRISB=0;		// PortB en sortie		
	INTCON2bits.RBPU = 0;	// PullUP PortB ON	

	// Initialisation de la liaison srie  9600b
	OpenUSART( 	USART_TX_INT_OFF  &
            	USART_RX_INT_OFF  &
            	USART_ASYNCH_MODE &		// mode asynchrone
            	USART_EIGHT_BIT   &		// 8bits
            	USART_CONT_RX     &
				USART_BRGH_HIGH,12);  	// [(8000000/38400)/16]-1	si hrl int 8MHz	
}
/*******************************************************************************************/
// Procedure de mesure distance
/*******************************************************************************************/
int mesure ()
{
	val=0;
	while(echopulse==1);
	trig=1;
	Delay10TCYx(3);		// Trig 20us
	trig=0;
	while(echopulse==0);
	do
	{
		val++;
		Delay10TCYx(1);	// mesure echo pulse
	}
	while(echopulse==1);
	if(val>1023) val=1023;
	return val;
}
/*******************************************************************************************/
//  Position zero
/*******************************************************************************************/
void zero1(void)
{
	do
	{
		c=!c;
		Delay10KTCYx(5);
	}
	while (opto!=0);
}
/*******************************************************************************************/
void zero2(void)
{
	do
	{
		c=!c;
		Delay10KTCYx(5);
	}
	while (opto!=1);
}
/*******************************************************************************************/

void main(void)
{
	long int j;
	int i;
	unsigned char flag1;
	unsigned char flag2;
	unsigned char sens;
	unsigned char angle;
	unsigned int result;
	unsigned char PFortD;
	unsigned char PFaibleD;
	Setup();
	i=0;flag1=0;flag2=0;trig=0;led=1;s=1;
	zero1();
	for(;;)
	{
		sens=1;s=!s;
		do
		{
			//**********************************************************************************
			//  mesure US
			//***********************************************************************************
			mesure();			// mesure distance
			if(val<100) buz=0;else buz=1;	// dtection obstacle trs proche
			val=1024-val;					// complement pour affichage appli. processing
			PFortD=val/256;					// rcupration poids fort, poids faible
			PFaibleD=val%256;
		//	printf("sens = %i",sens);		sortie des donnes en ascii pour contrle
		//	printf("PF = %i",PFortD);		ventuel
		//	printf("Pf = %i\n\r",PFaibleD);
			//***********************************************************************************
			// Rotation d'un pas
			//***********************************************************************************
			c=!c;led=!led;i++;			
			for (j=1;j<2000;j=j+1);		// tempo entre 2 mesures
			//***********************************************************************************
			// Transmission RS232 en binaire pour le sens horaire
			//***********************************************************************************
			while(BusyUSART()) ;		// debut de trame
			WriteUSART(0xff);

			while(BusyUSART()) ;		// PF angle
			WriteUSART(0);	

			while(BusyUSART()) ;		// Pf angle
			WriteUSART(i);

			while(BusyUSART()) ;		// PF distance
			WriteUSART(PFortD);

			while(BusyUSART()) ;		// Pf distance
			WriteUSART(PFaibleD);
	
			while(BusyUSART()) ;		// sens
			WriteUSART(sens);
		}
		while (i<180);
                if(opto==1)zero1();
		s=!s;sens=0;
                zero2();
		do
		{
			//***********************************************************************************
			//  mesure US
			//***********************************************************************************
			mesure();					// mesure distance
			if(val<100) buz=0;else buz=1;
			val=1024-val;			
			PFortD=val/256;
			PFaibleD=val%256;
		//	printf("sens = %i",sens);
		//	printf("PF = %i",PFortD);
		//	printf("Pf = %i\n\r",PFaibleD);
			//***********************************************************************************
			// Rotation d'un pas
			//***********************************************************************************
			c=!c;led=!led;i--;
			if(i<0) i=0;
			for (j=1;j<2000;j=j+1);
			//***********************************************************************************
			// Transmission RS232 en binaire pour le sens trigo
			//***********************************************************************************
			while(BusyUSART()) ;	// debut de trame
			WriteUSART(0xff);

			while(BusyUSART()) ;	// PF angle
			WriteUSART(0);

			while(BusyUSART()) ;	// Pf angle
			WriteUSART(i);

			while(BusyUSART()) ;	// PF distance
			WriteUSART(PFortD);

			while(BusyUSART()) ;	// Pf distance
			WriteUSART(PFaibleD);
	
			while(BusyUSART()) ;	// sens
			WriteUSART(sens);
		}
		while (opto==1);	// recalage sur le zro  chaque tour
	}
}